
--//by_vespan
active = false
carId = 257
returnCar = {}
vehicles = {}
AFK = {afk=false}
function main()
	while not isSampAvailable() do wait(0) end

	local f = io.open(getGameDirectory()..'/data/vehicles.ide','r+')
	for n in f:read('*a'):gmatch('[^\n]+') do
		if n:find("^%d+,%s+%S+") then
			vehicles[tonumber((n:match('^(%d+)')))] = true
			-- table.insert(vehicles,tonumber((n:match('^(%d+)'))))
		end
	end
	f:close()
	
	sampRegisterChatCommand('car_test',function(arg)
		if #arg == 0 or not arg:find('^%d+ %d+ %d+$') then
			sampAddChatMessage('/car_test [id car] [color1] [color2]',0xcccccc)
			return
		end
		local id,c1,c2 = arg:match('^(%d+) (%d+) (%d+)')
		id = tonumber(id)
		c1 = tonumber(c1)
		c2 = tonumber(c2)
		if (c1 > 255 or c2 > 255) or (c1 < 0 or c2 < 0) then
			sampAddChatMessage('/car_test [id car] [color1{AB1500}<255 & >0{cccccc}] [color2{AB1500}<255 & >0{cccccc}]',0xcccccc)
			return
		end
		if id < 400 or vehicles[id] == nil then
			sampAddChatMessage('/car_test {AB1500}invalid car model!{32CD32} The ID can be seen on the website https://arz-wiki.com',0xcccccc)
			return
		end
		--
		local x,y,z = getCharCoordinates(PLAYER_PED)
		local heading = getCharHeading(PLAYER_PED)
		returnCar = nil
		for k,v in ipairs(getAllVehicles()) do
			if select(2,sampGetVehicleIdByCarHandle(v)) == carId then
				local x,y,z = getCarCoordinates(v)
				local c1,c2 = getCarColours(v)
				returnCar = {
					x = x,
					y = y,
					z = z,
					model = getCarModel(v),
					hp = getCarHealth(v),
					heading = getCarHeading(v),
					color1 = c1,
					color2 = c2,
				}
			end
		end
		createVeh(carId,id,x,y,z,heading,c1,c2,1500)

		AFK = {
			x=x,
			y=y,
			z=z+0.3,
			afk = true
		}
		local r,h = sampGetCarHandleBySampVehicleId(carId)
		setCarHeading(h,heading)
		warpCharIntoCar(playerPed,h)
		active = true
	end)

	while true do wait(0)
		if isCharInAnyCar(PLAYER_PED) and select(2,sampGetVehicleIdByCarHandle(storeCarCharIsInNoSave(playerPed))) == carId and active then
			setCarEngineOn(storeCarCharIsInNoSave(playerPed),true)
		elseif active and not isCharInAnyCar(PLAYER_PED) then
			deleteCar(select(2,sampGetCarHandleBySampVehicleId(carId)))
			
			if returnCar ~= nil then
				createVeh(carId,returnCar.model,returnCar.x,returnCar.y,returnCar.z,returnCar.heading,returnCar.color1,returnCar.color2,returnCar.hp)
				returnCar = {}
			end
			active = false
			setCharCoordinates(PLAYER_PED,AFK.x,AFK.y,AFK.z)
			AFK.afk = false
		end
	end
end

function onReceivePacket()
	if AFK.afk then;	return false;	end
end
function onReceiveRpc(id,bs)
	if AFK.afk then;	return false;	end
end
function onSendRpc(id, bs, priority, reliability, orderingChannel, shiftTs)
	if AFK.afk then;	return false;	end
end
function onSendPacket(id, bitStream, priority, reliability, orderingChannel)
	if AFK.afk then;	return false;	end
end

function createVeh(id,model,posX,posY,posZ,angle,color1,color2,hp)
	local bs = raknetNewBitStream()

	raknetBitStreamWriteInt16(bs,id)
	raknetBitStreamWriteInt32(bs,model)
	raknetBitStreamWriteFloat(bs,posX)
	raknetBitStreamWriteFloat(bs,posY)
	raknetBitStreamWriteFloat(bs,posZ)
	raknetBitStreamWriteFloat(bs,angle)
	raknetBitStreamWriteInt8(bs,0)
	raknetBitStreamWriteInt8(bs,0)
	raknetBitStreamWriteFloat(bs,hp)
	raknetBitStreamWriteInt8(bs,0)
	raknetBitStreamWriteInt32(bs,0)
	raknetBitStreamWriteInt32(bs,0)
	raknetBitStreamWriteInt8(bs,0)
	raknetBitStreamWriteInt8(bs,0)
	raknetBitStreamWriteInt8(bs,1)
	for i = 1,14 do
		raknetBitStreamWriteInt8(bs,0)
	end

	raknetBitStreamWriteInt8(bs,0)
	raknetBitStreamWriteInt32(bs,color1)
	raknetBitStreamWriteInt32(bs,color2)

	raknetEmulRpcReceiveBitStream(164, bs)
	raknetDeleteBitStream(bs)

end